from endstone.plugin import Plugin
from endstone import ColorFormat
from endstone.command import CommandSenderWrapper
from endstone.event import event_handler, PlayerInteractEvent
class LikoFarm(Plugin):
    api_version = "0.5"

    def on_load(self) -> None:
        self.logger.info(f"{ColorFormat.GREEN}优秀的农场主加载成功！{ColorFormat.RESET}右击农作物即可采集")

    def on_enable(self):
        self.register_events(self)

    @event_handler
    def PlayerInteractEvent(self, event: PlayerInteractEvent):
        block = event.block
        player = event.player
        if event.has_block:
            # 检查block类型是否为wheat
            growth_crops = {
                "minecraft:wheat": {"growth": 7},
                "minecraft:carrots": {"growth": 7},
                "minecraft:potatoes": {"growth": 7},
                "minecraft:beetroot": {"growth": 7}
            }
            age_crops = {
                "minecraft:nether_wart": {"age": 3},
                "minecraft:cocoa":{"age": 2}
            }
            # 遍历作物字典，检查当前方块是否符合条件
            for crop_type, details in growth_crops.items():
                if block.type == crop_type:
                    block_states = block.data.block_states
                    growth = block_states.get("growth", None)

                    if growth == details["growth"]:
                        # 构造破坏命令
                        command = f"execute as \"{player.name}\" at @s run setblock {block.x} {block.y} {block.z} {crop_type}[\"growth\"=0] destroy"
                        try:
                            self.server.dispatch_command(CommandSenderWrapper(self.server.command_sender), command)
                        except Exception as e:
                            self.logger.error(f"无法执行命令: {e}")


            for crop_type, details in age_crops.items():
                if block.type == crop_type:
                    block_states = block.data.block_states
                    age = block_states.get("age", None)

                    if age == details["age"]:
                        # 构造破坏命令
                        if block.type == "minecraft:cocoa":
                            command = f"execute as \"{player.name}\" at @s run setblock {block.x} {block.y} {block.z} {crop_type}[\"direction\"={block_states.get("direction", None)}] destroy"
                        else:
                            command = f"execute as \"{player.name}\" at @s run setblock {block.x} {block.y} {block.z} {crop_type} destroy"

                        try:
                            self.server.dispatch_command(CommandSenderWrapper(self.server.command_sender), command)
                        except Exception as e:
                            self.logger.error(f"无法执行命令: {e}")